Esta documentación está archivada y no tiene mantenimiento.

try-catch (Referencia de C#)

La instrucción try-catch consta de un bloque try seguido de una o más cláusulas catch, las cuales especifican controladores para diferentes excepciones.

El bloque try contiene el código protegido que puede causar la excepción. Este bloque se ejecuta hasta que se produce una excepción o hasta completarse satisfactoriamente. Por ejemplo, el siguiente intento de convertir un objeto null provoca la excepción NullReferenceException:

object o2 = null;
try
{
    int i2 = (int)o2;   // Error
}

La cláusula catch se puede utilizar sin argumentos, en cuyo caso captura cualquier tipo de excepción y se conoce como cláusula catch general. También puede aceptar un argumento de objeto derivado de System.Exception, en cuyo caso trata una excepción específica. Por ejemplo:

catch (InvalidCastException e) 
{
}

Es posible utilizar más de una cláusula catch específica en la misma instrucción try-catch. En este caso, el orden de las cláusulas catch es importante, ya que las cláusulas catch se examinan por orden. Las excepciones más específicas se capturan antes que las menos específicas.

Se puede utilizar una instrucción throw en el bloque catch para volver a producir la excepción, la cual ha sido capturada por la instrucción catch. Por ejemplo:

catch (InvalidCastException e) 
{
    throw (e);    // Rethrowing exception e
}

Si desea volver a producir la excepción que está siendo actualmente controlada por una cláusula catch sin parámetros, use la instrucción throw sin argumentos. Por ejemplo:

catch
{
    throw;
}

Dentro de un bloque try, inicialice sólo variables declaradas en su interior; en caso contrario, puede producirse una excepción antes de que se complete la ejecución del bloque. Por ejemplo, en el siguiente ejemplo de código, la variable x se inicializa dentro del bloque try. Al intentar utilizar esta variable fuera del bloque try en la instrucción Write(x), se generará el siguiente error del compilador: Uso de variable local no asignada.

static void Main() 
{
    int x;
    try 
    {
        // Don't initialize this variable here.
        x = 123;
    }
    catch
    {
    }
    // Error: Use of unassigned local variable 'x'.
    Console.Write(x);
}

Para obtener más información acerca de catch, vea try-catch-finally.

En este ejemplo, el bloque try contiene una llamada al método MyMethod(), que puede producir una excepción. La cláusula catch contiene el controlador de excepciones, el cual simplemente muestra un mensaje en la pantalla. Cuando se realiza la llamada a la instrucción throw desde dentro de MyMethod, el sistema busca la instrucción catch y muestra el mensaje Exception caught.

// try_catch_example.cs
using System;
class MainClass
{
    static void ProcessString(string s)
    {
        if (s == null)
        {
            throw new ArgumentNullException();
        }
    }
    
    static void Main()
    {
        try
        {
            string s = null;
            ProcessString(s);
        }
        catch (Exception e)
        {
            Console.WriteLine("{0} Exception caught.", e);
        }
    }
}

Resultados del ejemplo

System.ArgumentNullException: Value cannot be null.
   at MainClass.Main() Exception caught.

En este ejemplo, se utilizan dos instrucciones catch. La excepción más específica, que aparece en primer lugar, se captura primero.

// try_catch_ordering_catch_clauses.cs
using System;
class MainClass
{
    static void ProcessString(string s)
    {
        if (s == null)
        {
            throw new ArgumentNullException();
        }
    }

    static void Main()
    {
        try
        {
            string s = null;
            ProcessString(s);
        }
        // Most specific:
        catch (ArgumentNullException e)
        {
            Console.WriteLine("{0} First exception caught.", e);
        }
        // Least specific:
        catch (Exception e)
        {
            Console.WriteLine("{0} Second exception caught.", e);
        }
    }
}

Resultados del ejemplo

System.ArgumentNullException: Value cannot be null.
   at MainClass.Main() First exception caught.

En el ejemplo anterior, si empieza con la cláusula catch menos específica, aparecerá el mensaje de error: A previous catch clause already catches all exceptions of this or a super type ('System.Exception')

No obstante, para capturar la excepción menos específica, debe reemplazar la instrucción throw por la siguiente:

throw new Exception();

Para obtener más información, vea las secciones siguientes de Especificación del lenguaje C#.

  • 5.3.3.13 Instrucciones Try-catch

  • 8.10 La instrucción try

  • 16 Excepciones

Mostrar: